<template>
  <div class="goodsCost pagePadding">
    <ex-table
      v-loading="loading"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @selection="selection_change"
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 10px 80px">
            <el-col :span="6" style="width: 303px">
              <period-date-picker
                :type="1"
                :width="'135px'"
                :size="searchSize"
                :start="parmValue.start"
                :end="parmValue.end"
                @timeReturned="handleTime"
              />
            </el-col>
            <el-col :span="4" style="width: 135px">
              <search-brand
                :value="brandid"
                :disabled="false"
                :size="'mini'"
                :isDetail="true"
                :names="parmValue.supplierName"
                :placeholder="'商品品牌'"
                @searchChange="brandidsearchChange"
              />
            </el-col>
            <el-col :span="6" style="width: 310px; padding: 0 0 0 10px">
              <good-class
                :value="parmValue.cat_id"
                @handleChange="goods_class_change"
                :disabled="false"
                :size="searchSize"
                :isDetail="false"
                :placeholder="'分类'"
              />
            </el-col>

            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="primary" :size="searchSize" @click="searchList">
                刷新
              </el-button>
            </el-col>
            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="warning" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="4" style="width: 226px">
              <el-select
                v-model="parmValue.status"
                filterable
                clearable
                :size="searchSize"
                placeholder="状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in statusList"
                  :key="'status' + item.code"
                  :label="item.name"
                  :value="item.code"
                />
              </el-select>
            </el-col>
            <el-col :span="4" style="width: 145px; padding: 0 0 0 10px">
              <el-select
                v-model="parmValue.isonline"
                filterable
                clearable
                :size="searchSize"
                placeholder="是否上线"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in isonlineoptions"
                  :key="'isonline' + item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-col>
            <el-col :span="4" style="width: 420px; padding: 0 0 0 10px">
              <el-input
                :size="searchSize"
                v-model="sinput"
                :maxlength="40"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="关键字"
                ><el-select
                  v-model="select"
                  slot="prepend"
                  style="width: 135px"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                  placeholder="关键字类型"
                >
                  <el-option label="商品编号" value="1" />
                  <el-option label="商品名称" value="2" /></el-select
              ></el-input>
            </el-col>

            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button
                :size="searchSize"
                type="success"
                style="float: right"
                @click="routeGoto('/goodsCost/gDetail', { id: 'add', type: 'add' })"
              >
                添加
              </el-button>
            </el-col>
          </el-row>
        </div></template
      >

      <template #good_thumb_img="{ scope }">
        <div
          v-if="scope.row.good_thumb_img"
          style="width: 20px; height: 20px"
          class="hover"
          v-viewer
        >
          <img
            :src="scope.row.good_thumb_img"
            style="display: inline-block; width: 100%; height: 100%"
            alt=""
          />
        </div>
      </template>
      <template #status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="
            (statusList.find((item) => item.code == scope.row.status) || {}).type || '--'
          "
          v-text="
            (statusList.find((item) => item.code == scope.row.status) || {}).name || '--'
          "
        ></el-tag>
      </template>
      <template #isonline="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.is_online == '0' ? 'warning' : ''"
          v-text="
            (isonlineoptions.find((item) => item.id == scope.row.is_online) || {}).name ||
            '--'
          "
        ></el-tag>
      </template>

      <template #operation="{ scope }">
        <el-tooltip
          v-if="scope.row.status !== '8'"
          effect="dark"
          content="详情"
          placement="top"
        >
          <i
            class="el-icon-view tb-icon"
            @click="getRouter('/goodsCost/gDetail', scope.row.spuCode)"
          ></i>
        </el-tooltip>

        <el-tooltip
          v-if="
            scope.row.status === '7' ||
            scope.row.status === '6' ||
            scope.row.status === '8'
          "
          effect="dark"
          content="修改"
          placement="top"
        >
          <i
            class="el-icon-edit tb-icon"
            @click="
              routeGoto('/goodsCost/gDetail', {
                id: scope.row.spuCode,
                type: 'edit',
              })
            "
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="scope.row.status === '4' || scope.row.status === '1'"
          effect="dark"
          content="修改基础信息"
          placement="top"
        >
          <i
            class="el-icon-c-scale-to-original tb-icon"
            @click="wantto(scope.row.is_online, scope.row.spuCode, scope.row.status, '2')"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="scope.row.status === '5' || scope.row.status === '1'"
          effect="dark"
          content="修改成本信息"
          placement="top"
        >
          <i
            class="el-icon-coin tb-icon"
            @click="wantto(scope.row.is_online, scope.row.spuCode, scope.row.status, '3')"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="!(scope.row.status === '7' || scope.row.status === '8')"
          effect="dark"
          content="复制商品"
          placement="top"
        >
          <i
            class="el-icon-document-copy tb-icon"
            @click="good_copy(scope.row.spuCode)"
          ></i>
        </el-tooltip>

        <!-- <el-tooltip effect="dark" content="删除" placement="top">
          <i class="el-icon-delete tb-icon" @click="deleteItem(scope.row.spuCode)"></i>
        </el-tooltip> -->
      </template>
    </ex-table>
  </div>
</template>
<script>
import asyncRequest from "@/apis/goodsCost";
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import { mapGetters } from "vuex";
import { listCol, options1, statusList } from "./columns";
export default {
  name: "goodsCost",
  mixins: [mixinPage, resToken],
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size", "business_companyNo"]),
    maxNo() {
      return this.business_companyNo;
    },
  },
  watch: {
    maxNo(val, oldval) {
      this.restSearch();
      // console.log(val, oldval);
    },
  },
  data() {
    return {
      dialogFormVisible: false,
      statusList,
      isonlineoptions: [
        { id: "0", name: "未上线" },
        { id: "1", name: "已上线" },
      ],
      options1: options1,
      loading: false,
      changeList: [],
      parmValue: {
        page: 1, // 页码
        size: 15, // 每页显示条数
        start: "",
        end: "",
        status: "",
        good_name: "",
        spucode: "",
        cat_id: [],
        brandid: "",
        good_type: "",
        companyNo: "",
        supplierNo: "",
        isonline: "",
        company_name: "", //创建人部门
        // creater: "",
      },
      sinput: "",
      select: "",
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: listCol,
      supplierNo: [],
      brandid: [],
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      // console.log(this.parmValue);
      const { page, size } = this.parmValue;
      if (this.parmValue.brandid.length > 0) {
        this.brandid = [this.parmValue.brandid];
      }

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      this.sinput = this.parmValue.sinput;
    } else {
      this.select = "1";
      //  this.sselect = "创建时间"
    }
    this.select = "1";
    this.supplierNo = [];

    this.searchList();
  },
  methods: {
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          type: "view",
        };

        //有多选框的条件
        this.parmValue.select = this.select;
        // this.parmValue.sselect = this.sselect ;
        this.parmValue.sinput = this.sinput;
        //
        console.log(this.parmValue);
        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    restSearch() {
      this.select = "1";
      this.sinput = "";
      this.supplierNo = [];
      this.brandid = [];
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.parmValue = {
        page: 1, // 页码
        size: 15, // 每页显示条数
        start: "",
        end: "",
        status: "",
        good_name: "",
        company_name: "", //创建人部门
        spucode: "",
        cat_id: [],
        brandid: "",
        good_type: "",
        isonline: "",
        companyNo: "",
        supplierNo: "",
      };
      this.searchList();
    },
    async wantto(isonline, spuCode, ntype, wtype) {
      const res = await asyncRequest.checkIsUpdate({ spuCode });
      const { code, data } = await this.useResHandle(res);
      if (code === 0) {
        const { is_allow_update } = data;
        if (is_allow_update + "" === "1") {
          this.routeGoto("/goodsCost/gDetail", {
            id: spuCode,
            type: wtype === "2" ? "editBase" : wtype === "3" ? "editCoin" : "",
          });
        } else {
          if (isonline + "" === "1") {
            this.$message.warning("已上线的商品需要下线才能修改！");
          } else {
            this.$message.warning("当前商品上线流程正在进行中，请下线再操作！");
          }
        }
      }
    },
    selection_change(e) {
      const { list } = e;
      this.changeList = list.length > 0 ? JSON.parse(JSON.stringify(list)) : [];
    },
    //商品品牌选择
    async brandidsearchChange(e) {
      const { id, label } = e ?? {};
      this.brandid = id ? [id] : [];
      this.parmValue.brandid = id || "";
      this.parmValue.supplierName = label || "";
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    // 时间
    async handleTime(e) {
      this.parmValue.start = e.startTime || "";
      this.parmValue.end = e.endTime || "";
      if (
        (this.parmValue.start !== "" && this.parmValue.end !== "") ||
        (this.parmValue.start === "" && this.parmValue.end === "")
      ) {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    async good_copy(spuCode) {
      await this.$confirm(`确定要复制该商品？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            spuCode: spuCode,
          };

          const res = await asyncRequest.copy(model);
          const { code } = await this.useResHandle(res);
          if (code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "复制商品成功！",
              message: "",
            });
            await this.searchList();
          } else {
            this.loading = false;
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },

    async deleteItem(codes) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            codes: [codes],
          };
          const res = await asyncRequest.delete(model);
          const { code } = await this.useResHandle(res);
          if (code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            await this.searchList();
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 刷新表格
    async searchList() {
      if (this.loading) return;
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;
      let item = JSON.parse(JSON.stringify(this.parmValue));
      item.spucode = this.select === "1" ? this.sinput : "";
      item.good_name = this.select === "2" ? this.sinput : "";
      item.cat_id = item.cat_id.length > 0 ? item.cat_id[item.cat_id.length - 1] : "";
      const res = await asyncRequest.list(item);
      const { code, data } = await this.useResHandle(res);
      if (code === 0) {
        const { list, count } = data;
        this.tableData = list;
        this.tableData.forEach((a) => {
          a.cat_name = "";
          let list = a.cat_info || [];
          list.forEach((b, i) => {
            a.cat_name += i == 0 ? b.name : "/" + b.name;
          });
        });
        this.pageInfo.total = Number(count);
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }

      this.loading = false;
    },
    //商品分类选择
    async goods_class_change(e) {
      this.parmValue.cat_id = e;
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
  },
};
</script>

<style lang="scss" scoped></style>
